;###############################################################################
/* ToolBox for LilBuilder

*/
;###############################################################################

;return toolbox own gui ID
Toolbox_vGuiID(){
  Return 2
}

;return toolbox own gui HWND
Toolbox_vHWND(NewHWND=""){
  static HWND
  If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

;return list of standard AHK controls 
ToolBox_StandardCtrls(){
  static StandardControls := "Text,Edit,ComboBox,Button,CheckBox,Radio,Picture,ListBox,ListView,TreeView,Tab,HotKey,GroupBox,DateTime,MonthCal,Progress,UpDown,Slider,StatusBar"
  Return StandardControls
}

;create ToolBox gui
Toolbox_Create() {
   local Toolbox_GuiID, Pos              ;global context
   Toolbox_GuiID := Toolbox_vGuiID()

   Gui %Toolbox_GuiID%:Font, bold
   gui %Toolbox_GuiID%:+LastFound +ToolWindow +LabelToolbox_

   gui %Toolbox_GuiID%:add, Text, x5, AHK controls
   
   ;picture content is used a varname !!!, see: Toolbox_OnClick
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Text.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Edit.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\ComboBox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Button.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\CheckBox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Radio.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Picture.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\ListBox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\ListView.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\TreeView.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Tab.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\HotKey.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Groupbox.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\DateTime.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\MonthCal.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Progress.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\UpDown.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\Slider.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Std\StatusBar.png
                                                             
   gui %Toolbox_GuiID%:add, Text, y+20, Custom controls      

   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Cst\HiEdit.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Cst\HLink.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Cst\RaGrid.png
   gui %Toolbox_GuiID%:add, Picture,      gToolbox_OnClick , res\Cst\IE.png

   Pos := Project("DockWindows") ? "x-1000" : "x0 y0"
   Gui %Toolbox_GuiID%:Show, %Pos%, ToolBox

   Toolbox_vHWND(WinExist() + 0)
}

;###############################################################################

;react on click on icon in toolbox
Toolbox_OnClick:
   Toolbox_OnClick()
return
Toolbox_OnClick() {
  GuiHWND := Selector_vGuiHWND()
  Toolbox_GuiID := Toolbox_vGuiID()

  ;clear selection
  Selector_Size(False)
  Selector_vCtrlHWND("No")
  Selector_vMultiHWND("No")
  Selector_Set2PosSize(-10,-10)

  ;get type by path of picture (!!! path of picture is VarName of control (A_GuiControl) !!!) 
  GuiControlGet, Type, %Toolbox_GuiID%: , %A_GuiControl%
  SplitPath, Type, ,,,Type
  
  ;re-enable Statusbar when previously deleted but avoid two statusbars
  If (Type = "StatusBar" AND StatusBarHWND := Gui(GuiHWND, "StatusBar")){
    If Gui(GuiHWND, "StatusBarDeleted") {            ;if deleted
      Gui(GuiHWND, "StatusBarDeleted", False)             ;revert deletion state
      GuiID := Gui(GuiHWND, "GuiID")
      CtrlID := Control(StatusBarHWND,"VarName")
      GuiControl, %GuiID%:Show, %CtrlID%                  ;show statusbar
      Gui_AddControl(GuiHWND,StatusBarHWND)               ;add statusbar to list of controls on gui
    }
    Else                                             ;don't try to add a second
      ToolTip("Gui has already a Statusbar",2000,"Continue")
    Return
  }

  ;create the control
  CtrlHWND := Control_CreateNew(Type, GuiHWND)

  ;return for statusbar
  If (Type = "StatusBar")
  
  ;set control as selected
  Selector_vCtrlHWND(CtrlHWND)
  
  ;move mouse to center of control
  If Gui(GuiHWND,"Toolwindow"){
    ;window frame height/width of a toolwindow gui
    SysGet, XFrame,  7   ;SM_CXFIXEDFRAME =  7   ;width of frame
    SysGet, YFrame,  8   ;SM_CYFIXEDFRAME =  8   ;height of frame
    SysGet, HCaption, 51 ;SM_CYSMCAPTION  = 51   ;height of caption, the whole title height is: SM_CYSMCAPTION + SM_CYFIXEDFRAME
  }Else{
    ;window frame height/width of a regular gui
    SysGet, XFrame, 32   ;SM_CXSIZEFRAME = 32    ;width of frame
    SysGet, YFrame, 33   ;SM_CYSIZEFRAME = 33    ;height of frame
    SysGet, HCaption, 4  ;SM_CYCAPTION   =  4    ;height of caption, the whole title height is: SM_CYCAPTION + SM_CYSIZEFRAME
  }
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%
  ControlGetPos, ,,cw,ch,, ahk_id %CtrlHWND%
  KeyWait, LButton     ;wait for release of LButton
  MouseMove, ux + cw // 2, uy + YFrame + HCaption + ch // 2

  Selector_Set2Ctrl()  ;set selector to control 

  Sleep, 20
  Selector_Size(True)
  Send {LButton down}  ;prepare movement
}

;###############################################################################

