;###############################################################################
/* MultiSelection for LilBuilder

*/
;###############################################################################

MultiSelection_CreateMenu(Menu_MultiSelection){
  MMenu_Add(Menu_MultiSelection, "Align left","","","iMultiSelection_AlignLeft")
  MMenu_Add(Menu_MultiSelection, "Align right","","","iMultiSelection_AlignRight")
  MMenu_Add(Menu_MultiSelection, "Center horizontal","","","iMultiSelection_CenterHori")
  MMenu_Add(Menu_MultiSelection)
  MMenu_Add(Menu_MultiSelection, "Align top","","","iMultiSelection_AlignTop")
  MMenu_Add(Menu_MultiSelection, "Align bottom","","","iMultiSelection_AlignBottom")
  MMenu_Add(Menu_MultiSelection, "Center vertical","","","iMultiSelection_CenterVert")
  MMenu_Add(Menu_MultiSelection)
  MMenu_Add(Menu_MultiSelection, "Distribute horizontal","","","iMultiSelection_DistributeHori")
  MMenu_Add(Menu_MultiSelection, "Distribute vertical","","","iMultiSelection_DistributeVert")
}

MultiSelection_ShowMenu:
  MMenu_Show(Menu_MultiSelection, Menu_vX(), Menu_vY(), "MultiSelection_OnSelection")
Return

MultiSelection_OnSelection:
  If MMenu_ID = MultiSelection_AlignLeft
    MultiSelection_AlignLeft(Menu_vGuiHWND(), Selector_vMultiHWND())
  Else If MMenu_ID = MultiSelection_AlignRight
    MultiSelection_AlignRight(Menu_vGuiHWND(), Selector_vMultiHWND())
  Else If MMenu_ID = MultiSelection_CenterHori
    MultiSelection_CenterHori(Menu_vGuiHWND(), Selector_vMultiHWND())
  Else If MMenu_ID = MultiSelection_DistributeHori
    MultiSelection_DistributeHori(Menu_vGuiHWND(), Selector_vMultiHWND())
Return

;###############################################################################

MultiSelection_AlignLeft(GuiHWND, ListCtrlHWND) {
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%                            ;get pos of user gui
  Selector_vPosSize(LeftSide, Y, W, H)                         ;get pos/size of selector
  LeftSide -= ux
  Loop, Parse, ListCtrlHWND, |                                     ;go through all controls in selection
    ControlMove,, LeftSide, , , , ahk_id %A_LoopField%             ;move control to left of selection
  Selector_Set2MultiSel()                                          ;update selector
}

MultiSelection_AlignRight(GuiHWND, ListCtrlHWND) {
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%                            ;get pos of user gui
  Selector_vPosSize(RigthSide, Y, W, H)                        ;get pos/size of selector
  RigthSide += W - ux
  Loop, Parse, ListCtrlHWND, |                                     ;go through all controls in selection
  {                                           
    ControlGetPos, ,,cw,,, ahk_id %A_LoopField%                         ;get current controls width
    ControlMove,, RigthSide - cw,  , , , ahk_id %A_LoopField%           ;move control to right side of selection
  }
  Selector_Set2MultiSel()                                          ;update selector
}

MultiSelection_CenterHori(GuiHWND, ListCtrlHWND) {
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%                            ;get pos of user gui
  Selector_vPosSize(CenterPos, Y, W, H)                        ;get pos/size of selector
  CenterPos += W / 2 - ux
  Loop, Parse, ListCtrlHWND, |                                     ;go through all controls in selection
  {                                           
    ControlGetPos, ,,cw,,, ahk_id %A_LoopField%                          ;get current controls width
    ControlMove,, CenterPos - cw / 2,  , , , ahk_id %A_LoopField%        ;move control to center psoition of selection
  }
  Selector_Set2MultiSel()                                          ;update selector
}

MultiSelection_DistributeHori(GuiHWND, ListCtrlHWND){
  WinGetPos, ux, uy,,, ahk_id %GuiHWND%                    ;get pos of user gui
  Selector_vPosSize(X, Y, W, H)                        ;get pos/size of selector

  TotalW = 0
  Cnt = 0
  Loop, Parse, ListCtrlHWND, |                             ;go through all controls in selection
  {                                           
    ControlGetPos, cx,,cw,,, ahk_id %A_LoopField%               ;get current controls x and width
    TotalW += cw                                                ;sum up width
    Cnt++                                                       ;count controls
    Order .= cx " " cw " " A_LoopField "`n"                     ;collect x/w and HWND
  }
  Sort, Order, N
  StringTrimRight, Order, Order, 1

  dx := (W - TotalW) / Cnt
  X -= ux 
  Loop, Parse, Order, `n                                   ;go through ordered controls
  {                                           
    StringSplit, item, A_LoopField, %A_Space%                 ;get width and hwnd 
    ControlMove,, X,  , , , ahk_id %item3%                    ;move control to new position
    X += item2 + dx                                           ;calculate position of next control 
  }
  Selector_Set2MultiSel()                                  ;update selector
}
